# Written by David Henningsson <david.henningsson@canonical.com>
# Copyright Canonical Ltd 2010. 
# Licensed under GPLv3.

from utils import run_subprocess
import os
import re
import logging
import time

def pulseaudio_dir():
    return os.path.expanduser("~/.pulse/")

def restorepulseaudio():
    d = pulseaudio_dir()
    if os.path.exists(d + "client.conf"):
        os.remove(d + "client.conf")
    if os.path.exists(d + "client.conf_dbtest_temp"):
        os.rename(d + "client.conf_dbtest_temp", d + "client.conf")

def getpulseaudio_streams():
    if run_subprocess(('pgrep', 'pulseaudio')).strip() == "":
        return None
    s = run_subprocess(('pacmd', 'list-sink-inputs'))
    result = re.findall('application.name = "([^"]*?)"', s)
    s = run_subprocess(('pacmd', 'list-source-outputs'))
    result += re.findall('application.name = "([^"]*?)"', s)
    return result
    

def killpulseaudio():
    d = pulseaudio_dir()
    if not os.path.exists(d):
        return
    if os.path.exists(d + "client.conf"):
        os.rename(d + "client.conf", d + "client.conf_dbtest_temp")
    f = open(d + "client.conf", "w")
    f.write("autospawn = no\n")
    f.close()

    if run_subprocess(('pgrep', 'pulseaudio')).strip() == "":
        return
    logging.debug("PulseAudio is running, trying to kill it")
    run_subprocess(('killall', 'pulseaudio'))
    



