# Written by David Henningsson <david.henningsson@canonical.com>
# Copyright Canonical Ltd 2010. 
# Licensed under GPLv3.

import os
import subprocess
import logging
import re

def run_subprocess(args):
    ''' Helper function to run a subprocess.  
      Returns stdout and logs a warning if anything goes to stderr. '''
    logging.debug("Run subprocess: {0}".format(args))
    # avoid localized strings
    env = os.environ
    env['LC_MESSAGES'] = 'C'
    sub_mon = subprocess.Popen(args,
        stdout=subprocess.PIPE, stderr=subprocess.PIPE, env=env)
    sub_out, sub_err = sub_mon.communicate()
    if sub_err is not None and (len(str(sub_err).strip()) > 0):
        logging.warn("Stderr from subprocess: {0}".format(sub_err))
    return sub_out


def get_asound_names():
    f = open("/proc/asound/cards", "r")
    result = []
    for line in f:
        m = re.search(' (\d+) \[(\w+)\s*\]: (.+)', line)
        if not m is None:
            result.append(m.groups(1)[0])
            result.append(m.groups(1)[1])
    return result



